(defun checkup ( pktH / pktHs lengH check)
; es wird geprft, ob, und wenn ja, wieviele Stellen hinter der Dezimalstelle vorhanden sind und ggf. wird auf 3 Nullen aufgefllt
    (setq pktHs (strcat "000" (rtos pktH 2 3)))          ; generell 3 Nullen vor den Wert schreiben, um sicher zustellen, dass die Stringlnge mind. 4 Zeichen hat
    (setq lengH (strlen pktHs))
    (setq check (substr pktHs (- lengH 3) 1)) 
    (if (= check ".")                                    ; berprfen, ob 4. Zeichen von hinten ein Pkt ist
        ()                                           
        (progn                                           ; wenn nicht, berprfen, ob 3. Zeichen von hinten ein Pkt ist
          (setq check (substr pktHs (- lengH 2) 1)) 
          (if (= check ".")
              (setq pktHs (strcat pktHs "0"))
              (progn                                     ; wenn nicht, berprfen, ob 2. Zeichen von hinten ein Pkt ist
                (setq check (substr pktHs (- lengH 1) 1)) 
                (if (= check ".")
                  (setq pktHs (strcat pktHs "00"))
                  (setq pktHs (strcat pktHs ".000"))     ; wenn nicht, wird generell die gesamte Endung hinzugefgt 
                )
              )
          )
        ) ; end erstes ELSE progn
    ) ; end if  
    (setq pktHs (substr pktHs 4))  
) ; end defun 

(defun ZtxtErzeug ( / efp efpR efpH )
;  Subroutine schreibt Koordinaten und setzt Kreis in Zeichnung
            (setq efp (trans (getpoint "\nEinfgepunkt:") 1 0))
            (setq efpR (nth 0 efp))
            (setq efpH (nth 1 efp))
            (entmake
                (list
                    '(0 . "CIRCLE")
                    '(410 . "Model")
                    (cons 10 (list efpR efpH 0.0))
                    (cons 40 (* 0.1 tgr))
                ) 
            )
            (entmake
                (list
                    '(0 . "TEXT")
                    '(410 . "Model")
                    (cons 1 (strcat "N="(checkup H)))
                    (cons 10 (list (+ efpR (* 0.6 tgr)) efpH 0.0))
                    (cons 11 (list (+ efpR (* 0.6 tgr)) efpH 0.0))
                    (cons 40 tgr)
                    (cons 41 *BF*)
                ) 
            )
            (entmake  
                (list
                    '(0 . "TEXT")
                    '(410 . "Model")
                    (cons 1 (strcat "E="(checkup R)))
                    (cons 10 (list (+ efpR (* 0.6 tgr)) (- efpH (* 1.2 tgr)) 0.0))
                    (cons 11 (list (+ efpR (* 0.6 tgr)) (- efpH (* 1.2 tgr)) 0.0))
                    (cons 40 tgr)
                    (cons 41 *BF*)
                ) 
	    	)
			(entmake  
                (list
                    '(0 . "TEXT")
                    '(410 . "Model")
                    (cons 1 (strcat "Z=" Zhhe))
                    (cons 10 (list (+ efpR (* 0.6 tgr)) (- efpH (* 2.4 tgr)) 0.0))
                    (cons 11 (list (+ efpR (* 0.6 tgr)) (- efpH (* 2.4 tgr)) 0.0))
                    (cons 40 tgr)
                    (cons 41 *BF*)
                )  
            )
)

(defun c:GK (/ MP R H datei NR exitflag1 prefix tgr ZE ZEtxt txtJN )
; Eintrag von Gauss-Krger-Koordinaten in Zeichnung und in TXT Datei
 (setq ZE 1000)
 (setq ZEtxt (cond
             ((= ZE 1) "METER")
             ((= ZE 10) "DEZIMETER")   
             ((= ZE 100) "ZENTIMETER") 
             ((= ZE 1000) "MILLIMETER")
             ((/= 3 4 ) "FEHLENDE ZEICHNUNGSEINHEIT") 
            )
 )
 (setvar "SAVEFILEPATH" "d:/a_temp/")
 (setq datei (getfiled "Speichern unter" (getvar "SAVEFILEPATH") "TXT" 1))
; (setq datei "C://GK-Koordinaten.txt")
 (setq exitflag1 nil)
 (setq txtJN nil)
 (if (not *MS*) (setq *MS* 250)) ; falls kein globaler Mastab vorhanden -> auf 1: 250 setzen
 (setq tgr (* 3.5 *MS*)) ; Texthhe, hinterer Wert gibt Mastab 1: ... an
 (if (not *BF*) (setq *BF* 0.5)) 
 (setq txtJN (getstring "\nKoordinaten in die Zeichnung bernehmen? j/<N>")) 
 (setq prefix (getstring "\nTextprefix: "))
  (if (not prefix) (setq prefix ""))  
 (setq NR (getint "\nStartnummer: " ))
  (if (not NR) (setq NR 1)) 

; (princ (strcat "\nDie Koordinaten werden in die Datei " datei " gespeichert."))
 (princ (strcat "\nDie Berechnung der Koordinaten ist auf Zeichnungseinheit " ZEtxt " eingestellt."))

 (setq file (open datei "a"))                   
 (write-line "_,_,_" file)
 (close file)

 (while (not exitflag1)
   (setq MP (getpoint "\nPunkt:"))
   (setq Zhhe (getstring "\nZ-Hhe:"))  
	  (if (not MP)
         (setq exitflag1 T)
         (progn
            (setq R (/ (nth 0 MP) ZE))
            (setq H (/ (nth 1 MP) ZE))
            (princ (strcat prefix (itoa NR) " | N= " (checkup H) " | E= " (checkup R) " | Z= " Zhhe)) ;Sub
            (setq file (open datei "a"))                   
            (write-line (strcat prefix (itoa NR) "," (checkup H) "," (checkup R) "," Zhhe) file) ;Sub
            (close file)
            (setq NR (1+ NR)) 
            (if (or (= txtJN "j") (= txtJN "J"))
              (ZtxtErzeug) ;Sub
            )
         )           
     )
 )
)